<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MonitoringCapabilityAccessControlStructure StructType
 * Meta informations extracted from the WSDL
 * - documentation: Type for Monitoring Service Capability access control.
 * @subpackage Structs
 */
class MonitoringCapabilityAccessControlStructure extends CapabilityAccessControlStructure
{
    /**
     * The CheckOperatorRef
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: CheckOperatorRef
     * @var bool
     */
    public $CheckOperatorRef;
    /**
     * The CheckLineRef
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: CheckLineRef
     * @var bool
     */
    public $CheckLineRef;
    /**
     * The CheckMonitoringRef
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: CheckMonitoringRef
     * @var bool
     */
    public $CheckMonitoringRef;
    /**
     * Constructor method for MonitoringCapabilityAccessControlStructure
     * @uses MonitoringCapabilityAccessControlStructure::setCheckOperatorRef()
     * @uses MonitoringCapabilityAccessControlStructure::setCheckLineRef()
     * @uses MonitoringCapabilityAccessControlStructure::setCheckMonitoringRef()
     * @param bool $checkOperatorRef
     * @param bool $checkLineRef
     * @param bool $checkMonitoringRef
     */
    public function __construct($checkOperatorRef = null, $checkLineRef = null, $checkMonitoringRef = null)
    {
        $this
            ->setCheckOperatorRef($checkOperatorRef)
            ->setCheckLineRef($checkLineRef)
            ->setCheckMonitoringRef($checkMonitoringRef);
    }
    /**
     * Get CheckOperatorRef value
     * @return bool|null
     */
    public function getCheckOperatorRef()
    {
        return $this->CheckOperatorRef;
    }
    /**
     * Set CheckOperatorRef value
     * @param bool $checkOperatorRef
     * @return \StructType\MonitoringCapabilityAccessControlStructure
     */
    public function setCheckOperatorRef($checkOperatorRef = null)
    {
        // validation for constraint: boolean
        if (!is_null($checkOperatorRef) && !is_bool($checkOperatorRef)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($checkOperatorRef)), __LINE__);
        }
        $this->CheckOperatorRef = $checkOperatorRef;
        return $this;
    }
    /**
     * Get CheckLineRef value
     * @return bool|null
     */
    public function getCheckLineRef()
    {
        return $this->CheckLineRef;
    }
    /**
     * Set CheckLineRef value
     * @param bool $checkLineRef
     * @return \StructType\MonitoringCapabilityAccessControlStructure
     */
    public function setCheckLineRef($checkLineRef = null)
    {
        // validation for constraint: boolean
        if (!is_null($checkLineRef) && !is_bool($checkLineRef)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($checkLineRef)), __LINE__);
        }
        $this->CheckLineRef = $checkLineRef;
        return $this;
    }
    /**
     * Get CheckMonitoringRef value
     * @return bool|null
     */
    public function getCheckMonitoringRef()
    {
        return $this->CheckMonitoringRef;
    }
    /**
     * Set CheckMonitoringRef value
     * @param bool $checkMonitoringRef
     * @return \StructType\MonitoringCapabilityAccessControlStructure
     */
    public function setCheckMonitoringRef($checkMonitoringRef = null)
    {
        // validation for constraint: boolean
        if (!is_null($checkMonitoringRef) && !is_bool($checkMonitoringRef)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($checkMonitoringRef)), __LINE__);
        }
        $this->CheckMonitoringRef = $checkMonitoringRef;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MonitoringCapabilityAccessControlStructure
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
